# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import json
import os
import string
import xml.etree.ElementTree as ET
# Create your views here.
from collections import OrderedDict

from datetime import datetime
from django.http import HttpResponse, Http404, JsonResponse
from django.shortcuts import render, redirect
from reportlab.lib.pagesizes import letter
from reportlab.pdfgen import canvas
from django.views.decorators.csrf import csrf_exempt

from GeoInt_SIDT.settings import BASE_URL
from catalog.models import Purchase

from reportlab.pdfgen.canvas import Canvas
from reportlab.lib.pagesizes import letter
from reportlab.lib.styles import getSampleStyleSheet
from reportlab.lib.units import inch
from reportlab.lib import colors
from reportlab.platypus import Paragraph, Frame, Spacer, Image, Table, TableStyle, SimpleDocTemplate, PageBreak
from reportlab.graphics.charts.barcharts import VerticalBarChart
from reportlab.graphics.shapes import Drawing, String
from reportlab.graphics.charts.textlabels import Label, LabelOffset
from reportlab.graphics.charts.legends import Legend

# -------------------------------------------------------------------------------

########### lee archivo de configuración ################
dirname = os.path.dirname(__file__)
configfile = os.path.join(dirname, '../config/config.json')

with open(configfile, 'r') as f:
    config = json.load(f)

USERS_PATH = config['PATHS']['PATH_USERS']


###########################################################
def report_L2ASCL(request, purchase_id):
    template = "sclData.html"
    reporteDir = 'mask'
    folders = ""
    purchase = Purchase.objects.values('user__email', 'is_public', 'search__search_name', 
                                        'search__process_id__name').get(pk=purchase_id)
    email = purchase['user__email']
    path = USERS_PATH + email + '/' + purchase_id + '/'
    scl_data_path = USERS_PATH + email + "/" + purchase_id + "/scl_data.json"

    with open(USERS_PATH + email + "/" + purchase_id + "/findProducts.json") as p:
        dataProduct = json.load(p)
        startDate = str(dataProduct['startDate'])[:4] + '-' + str(dataProduct['startDate'])[4:6] + '-' + str(
            dataProduct['startDate'])[6:8]
        endDate = str(dataProduct['endDate'])[:4] + '-' + str(dataProduct['endDate'])[4:6] + '-' + str(
            dataProduct['endDate'])[6:8]

    graphData, label, defaultLabel, defaultDataset, datasets = ProcessChartData(scl_data_path)

    image_path = email + "/" + purchase_id + "/" + "out/" + reporteDir + "/TCI/thumbnails/"
    SCL_path = email + "/" + purchase_id + "/" + "out/" + reporteDir + "/SCL/"

    if os.path.exists(path + reporteDir + ".pdf"):
        print ("si existe")
    else:
        PDFGenerator(request, path, reporteDir, datasets)

    searchInfo = {
        "title": purchase['search__search_name'],
        "process": purchase['search__process_id__name'],
        "startDate": startDate,
        "endDate": endDate,
        "clouds": dataProduct['clouds'], 
        "platform": dataProduct['platform'],
        "productLevel": dataProduct['productLevel'],
        "polygon": dataProduct['wkt'],
        "report_name": "SCL Image Classification Data(Km²)"
    }

    return render(request, template, {"graphData": json.dumps(graphData),
                                      "searchInfo": searchInfo, "IMAGE_PATH": image_path,
                                      "SCL_PATH": SCL_path, 'dafaultLabel': defaultLabel,
                                      'defaultDataSet': defaultDataset, "folders": folders,
                                      "zone": reporteDir, "purchaseID": purchase_id,
                                      "labels": graphData['data']['labels'],
                                      "email": email})


    # -------------------------------------------------------------------------------def Reports(request):


def Reports(request):
    progress = 0
    productList = []
    size = 0
    folders = []
    zip = ""
    product_list = Purchase.objects.values('id', 'productList', 'aggreg_date', 'search__clouds', 'search__startDate',
                                           'search__endDate', 'search__process_id__name', 'search__search_name',
                                           'is_public').filter(
        user_id=request.user.id, purchased=1)
    for producto in product_list:
        log_info = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

        #####################################################
        #                progress bar                       #
        #####################################################
        if os.stat(log_info).st_size == 0:
            progress = 0
        else:
            if 'Linking Products...' in open(log_info).read():
                progress = 20
            if 'Merging Images...' in open(log_info).read():
                progress = 40
            if 'Deleting Images...' in open(log_info).read():
                progress = 50
            if 'Extracting SCL information...' in open(log_info).read():
                progress = 60
            if 'Finalizing...' in open(log_info).read():
                progress = 100
                # item = Purchase.objects.filter(pk=producto['id'])
                # item = Purchase.objects.get(pk=producto['id'])
                # item.progress = progress
                # item.save()

        with open(log_info, 'r') as myfile:
            log = myfile.read().replace('\n', '')

        for p in json.loads(producto['productList']):
            size = size + float(p['info']['size'][:-3])
            if size > 1000:
                size2 = size / 1000
                final_size = str(round(size2, 2)) + " GB"
            else:
                final_size = str(round(size, 2)) + " MB"

        initial_folder = "."
        absolute_path = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/"
        if not os.path.exists(absolute_path):
            print("folder out noes not exists")
        else:
            for files in os.listdir(absolute_path):
                if files == 'scl_data.json':
                    # print(files)
                    initial_folder = files[:8]
                    break
                elif files.endswith('_sclData.json'):
                    initial_folder = files[:14]
                    # if len(folders) == 0:
                    #    initial_folder = "../#"
                    # else:
                    #    initial_folder = folders.pop(0) + "_sclData"

        print(initial_folder)

        zip_path = USERS_PATH + request.user.email + "/" + str(producto['id'])
        # print(zip_path)

        # "../ static / reports / tmpImages / repsat_test_dev / umorales @ centrogeo.edu.mx / "+str(producto['id']) / myzip.zip"

        wkt = USERS_PATH + request.user.email + "/" + str(producto['id']) + "/findProducts.json"
        with open(wkt, 'r') as jsonfile:
            polygon = json.load(jsonfile)

        for file in os.listdir(zip_path):
            if file.endswith(".zip"):
                zip = zip_path + "/" + file
        productList.append({
            "search_name": producto['search__search_name'],
            "process": producto['search__process_id__name'],
            "purchase_date": producto['aggreg_date'],
            "startDate": producto['search__startDate'],
            "endDate": producto['search__endDate'],
            "clouds": producto['search__clouds'],
            "size": final_size,
            "purchase_id": producto['id'],
            "progress": progress,
            "log_info": log,
            "initial_folder": initial_folder,
            "zip": zip,
            "polygon": polygon['wkt'],
            "is_public": producto['is_public'],
        })
        size = 0
        final_size = 0
        log_info = ""
        progress = 0
        initial_folder = ""
        zip = ""
        wkt = ""

    return render(request, 'Reports.html', {"productList": productList})


# ------------------------------------------------------------------------
def wsProcessProgress(request):
    if request.is_ajax():
        progress = 0
        productList2 = []
        product_list = Purchase.objects.values('id', 'user__email', 'productList', 'aggreg_date', 'search__clouds',
                                               'search__startDate', 'search__endDate',
                                               'search__process_id__name', 'progress').filter(user_id=request.user.id,
                                                                                              purchased=1)
        for producto in product_list:
            log_info = USERS_PATH + producto['user__email'] + "/" + str(producto['id']) + "/L2ASCL_AreaProcessing.log"

            #####################################################
            #                progress bar                       #
            #####################################################
            if os.stat(log_info).st_size == 0:
                progress = 0
            else:
                if 'Linking Products...' in open(log_info).read():
                    progress = 20
                if 'Merging Images...' in open(log_info).read():
                    progress = 40
                if 'Deleting Images...' in open(log_info).read():
                    progress = 50
                if 'Extracting SCL information...' in open(log_info).read():
                    progress = 60
                if 'Finalizing...' in open(log_info).read():
                    progress = 100

            # item = Purchase.objects.get(pk=producto['id'])
            # item.progress = progress
            # item.save()

            productList2.append({
                "purchase_id": producto['id'],
                "progress": progress,
            })

            progress = 0
            log_info = ""

        # productList2 = []
        # product_list = Purchase.objects.values('id', 'progress').filter(user_id=request.user.id, purchased=1)
        # for producto in product_list:
        #     productList2.append({
        #         "purchase_id": producto['id'],
        #         "progress": producto['progress'],
        #     })
        return HttpResponse(json.dumps(productList2))
    else:
        raise Http404


# tiles
def tiles(request, purchase_id, report, layer_type, date, z, x, y):
    purchase = Purchase.objects.values('user__email', 'is_public').filter(pk=purchase_id)
    email = purchase[0]['user__email']

    split = '/split' if layer_type[:3] == "SCL" else ''
    layer_class = layer_type[3:] if layer_type[:3] == "SCL" else ''
    m_number = '60' if layer_type[:3] == "SCL" else '10'

    image_path = "{}{}/{}/out/{}/{}{}/tiles/{}_{}_{}m{}/{}/{}/{}.png".format(
        USERS_PATH, email, purchase_id, report, layer_type[:3], split,
        date, layer_type[:3], m_number, layer_class, z, x, y
    )

    if not os.path.exists(image_path):
        # raise Http404
        return HttpResponse(None, content_type="image/png")

    image = open(image_path, "rb").read()
    return HttpResponse(image, content_type="image/png")


# read a xml file with tiles info to display and return that info
@csrf_exempt
def tileinfo(request):
    if request.is_ajax():
        req = dict(request.POST)

        purchase = Purchase.objects.values('user__email').filter(pk=int(req['purchase_id'][0]))
        email = purchase[0]['user__email']

        resource_path = "{}{}/{}/out/{}/TCI/tiles/{}_TCI_10m/tilemapresource.xml".format(
            USERS_PATH, email, req['purchase_id'][0], req['report'][0],
            req['date'][0]
        )

        if not os.path.exists(resource_path):
            raise Http404

        tree = ET.parse(resource_path)
        bounding_box = tree.find('BoundingBox')
        sets = [int(set.get('order')) for set in tree.findall('TileSets/TileSet')]
        origin = tree.find('Origin')

        return JsonResponse({
            'boundingBox': [
                float(bounding_box.get('minx')),
                float(bounding_box.get('miny')),
                float(bounding_box.get('maxx')),
                float(bounding_box.get('maxy'))
            ],
            'zoom': {
                'max': int(max(sets)),
                'min': int(min(sets))
            },
            'origin': [float(origin.get('x')), float(origin.get('y'))],
            'projection': tree.find('SRS').text
        })
    else:
        raise Http404


# ------------------------------------------------------------------------
# take the data and make ready for paragraph
def dataToParagraph(name, data):
    p = '<strong>Subject name: </strong>' + name + '<br/>' + '<strong>Data: </strong>  ('
    for i in range(len(data)):
        p += str(data[i])
        if i != len(data) - 1:
            p += ', '
        else:
            p += ')'
    return p


# take the data and convert to list of strings ready for table
def dataToTable(name, data):
    data = [str(x) for x in data]
    data.insert(0, name)
    return data


# create the table for our document
def myTable(path1, path2, basefile):
    image1 = Image(path1, height=300, width=200, mask='auto')
    path, dirs, files = next(os.walk(path2))
    for file in files:

        if file.startswith(basefile[:8]):
            if file.endswith('.tif') and not file.endswith('0.tif'):
                # image2 = Image(path2 + file, height=300, width=200, mask='auto')
                image2 = image1

    data = [['TCI', 'SCL'], [image1, image2]]

    t = Table(data)
    GRID_STYLE = TableStyle(
        [
            ('ALIGN', (0, 0), (-1, -1), 'CENTER'),
            ('VALIGN', (0, 0), (-1, -1), 'TOP'),
        ],
    )

    t.setStyle(GRID_STYLE)
    return t


# create a bar chart and specify positions, sizes, and colors
def myBarChart(data, maxi, fecha):
    drawing = Drawing(600, 200)

    bc = VerticalBarChart()
    bc.x = 50
    bc.y = 50
    bc.height = 125
    bc.width = 500
    bc.data = data
    bc.barWidth = .3 * inch
    bc.groupSpacing = .2 * inch

    bc.strokeColor = colors.black

    bc.valueAxis.valueMin = 0
    bc.valueAxis.valueMax = maxi
    bc.valueAxis.valueStep = 50

    bc.categoryAxis.labels.boxAnchor = 'ne'
    bc.categoryAxis.labels.dx = 8
    bc.categoryAxis.labels.dy = -2
    catNames = fecha[6:8] + "/" + fecha[4:6] + "/" + fecha[0:4]

    catNames = catNames.split()
    bc.categoryAxis.categoryNames = catNames

    bc.bars[0].fillColor = colors.brown
    bc.bars[1].fillColor = colors.lightgrey
    bc.bars[2].fillColor = colors.gray
    bc.bars[3].fillColor = colors.lightblue
    bc.bars[4].fillColor = colors.darkgray
    bc.bars[5].fillColor = colors.green
    bc.bars[6].fillColor = colors.yellow
    # bc.bars[7].fillColor = colors.black

    bc.barSpacing = 1
    bc.categoryAxis.labels.dx = 8
    bc.categoryAxis.labels.dy = -2
    bc.barLabelFormat = '%f km²'
    bc.barLabels.nudge = 7
    bc.valueAxis.labelTextFormat = '%d km²'
    bc.valueAxis.valueMin = 0

    drawing.add(bc)

    return drawing


# add a legend for the bar chart
def myBarLegend(drawing, labels):
    "Add sample swatches to a diagram."

    d = drawing or Drawing(400, 200)

    swatches = Legend()
    swatches.alignment = 'right'
    swatches.x = 80
    swatches.y = 160
    swatches.deltax = 60
    swatches.dxTextSpace = 10
    swatches.columnMaximum = 4
    items = [
        (colors.brown, labels[0]),
        (colors.lightgrey, labels[1]),
        (colors.gray, labels[2]),
        (colors.lightblue, labels[3]),
        (colors.darkgray, labels[4]),
        (colors.green, labels[5]),
        (colors.yellow, labels[6] + "km2"),
        # (colors.black, labels[7]),
    ]
    swatches.colorNamePairs = items

    d.add(swatches, 'legend')

    return d


def PDFGenerator(request, ruta, reporteDir, datasets):
    thumbs = ruta + 'out/' + reporteDir + '/TCI/thumbnails/'
    SCL = ruta + 'out/' + reporteDir + '/SCL/split/'
    story = []
    # define the style for our paragraph text
    styles = getSampleStyleSheet()
    styleN = styles['Normal']

    # Header
    im = Image(USERS_PATH + 'header.png', width=300, height=70)
    im.hAlign = 'CENTER'
    story.append(im)

    story.append(PageBreak())

    path, dirs, files = next(os.walk(thumbs))
    print (len(files))
    for index, file in enumerate(files):
        values = []
        labels = []
        maxi = 0
        #for data in datasets:
        for data in datasets[:len(datasets) - 1]:
            if maxi > data['data'][index]:
                maxi = maxi
            else:
                maxi = data['data'][index]
            #print (maxi)
            values.append([data['data'][index]])
            labels.append(data['label'])

        path1 = thumbs + file
        # Header
        im = Image(USERS_PATH + 'header.png', width=300, height=70)
        im.hAlign = 'CENTER'
        story.append(im)

        story.append(Spacer(1, .5 * inch))

        # add the title
        # story.append(Paragraph("<strong>Results for Vizard Experiment</strong>", styleN))
        # story.append(Spacer(1, .25 * inch))

        # convert data to paragraph form and then add paragraphs
        # story.append(Paragraph(dataToParagraph(subject1, results1), styleN))
        # story.append(Spacer(1, .25 * inch))
        # story.append(Paragraph(dataToParagraph(subject2, results2), styleN))
        # story.append(Spacer(1, .5 * inch))



        # table with images
        story.append(myTable(path1, SCL, file))
        story.append(Spacer(1, .5 * inch))

        # add barchart and legend
        #drawing = myBarChart(values[:len(values) - 1], maxi, file)
        drawing = myBarChart(values, maxi, file)
        #drawing = myBarLegend(drawing, labels[:len(labels) - 1])
        drawing = myBarLegend(drawing, labels)
        drawing.hAlign = 'CENTER'
        story.append(drawing)

        story.append(PageBreak())

    # build our document with the list of flowables we put together
    doc = SimpleDocTemplate(ruta + reporteDir + ".pdf", pagesize=letter, topMargin=0)
    doc.build(story)
    pass


# -----------------------------------------------------------------------------------------------------------------
def ProcessChartData(path):
    with open(path) as f:
        json_data = OrderedDict(json.load(f))

        graphData = dict()
        graphData['type'] = "line"

        data = dict()
        data['labels'] = [k for k, v in sorted(json_data.items())]
        #		data['click']="chartOnClick"
        data['datasets'] = list()
        labels = set()
        for d in json_data:
            labels |= set(json_data[d].keys())
        labels.remove('date')

        labelNames = [
            "No Data", "Saturated", "Shadows", "Cloud Shadows", "Vegetation",
            "Not-Vegetated", "Water", "Unclassified", "Clouds", "Snow"
        ]

        colors = [
            "#383838", "#de3d3d", "#696767", "#98775b", "#44ba5d", "#fff98b",
            "#659acc", "#ababab", "#dddddd", "#ff8afa"
        ]

        for l in labels:
            item = dict()
            item['label'] = labelNames[int(l)]

            # item['fill'] = "false"
            # if l == "0":
            item['hidden'] = "true"
            item['data'] = [v[l] * 60 * 60 / 1000000. if (l in v) else 0 for k, v in sorted(json_data.items())]
            item['backgroundColor'] = colors[int(l)]
            data['datasets'].append(item)

        data['datasets'].sort(key=lambda k: max(k['data']))

        # PDFGenerator(request, path, reporteDir,data['datasets'])

        graphData['data'] = data
        label = graphData['data']['labels'][0]
        defaultLabel = graphData['data']['labels'][0]
        defaultDataset = label[0:4] + "/" + label[4:6] + "/" + label[6:]
    return graphData, label, defaultLabel, defaultDataset, data['datasets']


# ---------------------------------------------------------------------------------
def wsIs_Public(request):
    if request.is_ajax():
        status = request.GET.get("status")
        path = "/reports/" + request.GET.get("purchase_id") + "/scl_data"

        purchase = Purchase.objects.get(pk=request.GET.get("purchase_id"))
        purchase.is_public = request.GET.get("status")
        purchase.save()
        # print (purchase.aggreg_date)


        return HttpResponse("hola")
    else:
        raise Http404
